Package ghidra.app.util.bin.format.dwarf.macro

# Class DWARFMacroHeader

java.lang.Object
ghidra.app.util.bin.format.dwarf.macro.DWARFMacroHeader

public class DWARFMacroHeader extends Object
Represents a DWARF Macro Header

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final DWARFMacroHeader`
  `EMTPY`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DWARFMacroHeader(long startOffset, int version, int flags, long debug_line_offset, int intSize, long entriesStartOffset, DWARFCompilationUnit cu, DWARFLine line, Map<Integer,List<DWARFForm>> opcodeMap)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `DWARFCompilationUnit`
  `getCompilationUnit()`
  `long`
  `getDebug_line_offset()`
  `List<DWARFMacroInfoEntry>`
  `getEntries()`
  `long`
  `getEntriesStartOffset()`
  `int`
  `getIntSize()`
  `DWARFLine`
  `getLine()`
  `Map<Integer,List<DWARFForm>>`
  `getOpcodeMap()`
  `static List<DWARFMacroInfoEntry>`
  `readMacroEntries(BinaryReader reader, DWARFMacroHeader macroHeader)`
  `static DWARFMacroHeader`
  `readV5(BinaryReader reader, DWARFCompilationUnit cu)`
  Reads a `DWARFMacroHeader` from a stream.
  `String`
  `toString()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### EMTPY

    public static final DWARFMacroHeader EMTPY

- ## Constructor Details

  - ### DWARFMacroHeader

    public DWARFMacroHeader(long startOffset, int version, int flags, long debug_line_offset, int intSize, long entriesStartOffset, DWARFCompilationUnit cu, DWARFLine line, Map<Integer,List<DWARFForm>> opcodeMap)

- ## Method Details

  - ### readV5

    public static DWARFMacroHeader readV5(BinaryReader reader, DWARFCompilationUnit cu) throws IOException
    Reads a `DWARFMacroHeader` from a stream.
    Parameters:
      `reader` - source of bytes
      `cu` - `DWARFCompilationUnit` that pointed to this macro header
    Returns:
      macro header, never null
    Throws:
      `IOException` - if reading fails

  - ### readMacroEntries

    public static List<DWARFMacroInfoEntry> readMacroEntries(BinaryReader reader, DWARFMacroHeader macroHeader) throws IOException
    Throws:
      `IOException`

  - ### getLine

    public DWARFLine getLine()

  - ### getDebug_line_offset

    public long getDebug_line_offset()

  - ### getIntSize

    public int getIntSize()

  - ### getEntriesStartOffset

    public long getEntriesStartOffset()

  - ### getEntries

    public List<DWARFMacroInfoEntry> getEntries() throws IOException
    Throws:
      `IOException`

  - ### getCompilationUnit

    public DWARFCompilationUnit getCompilationUnit()

  - ### getOpcodeMap

    public Map<Integer,List<DWARFForm>> getOpcodeMap()

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`